/*
 * my_queue.h
 *
 *  Created on: Mar 19, 2013
 *      Author: promulo
 */

#ifndef MY_QUEUE_H_
#define MY_QUEUE_H_

#include "my_defines.h"

typedef MyNodeSingle QueueNode;

class MyQueue {
 public:
	MyQueue();

	virtual ~MyQueue();

	inline bool empty() { return m_size == 0; }

	void enqueue(int element);

	int dequeue();

	inline int size() { return m_size; }

 private:
	QueueNode* m_head;
	QueueNode* m_tail;
	int m_size;

};

#endif /* MY_QUEUE_H_ */
