/*
 * main.cpp
 *
 *  Created on: Mar 19, 2013
 *      Author: promulo
 */

#include <iostream>

#include "../headers/my_stack.h"
#include "../headers/my_queue.h"
#include "../headers/my_list.h"

using namespace std;

int main() {
	MyStack stack;

	stack.push(3);
	stack.push(2);
	stack.push(1);

	while (!stack.empty()) {
		cout << stack.pop() << endl;
	}

	MyQueue queue;
	queue.enqueue(1);
	queue.enqueue(2);
	queue.enqueue(3);

	while (!queue.empty()) {
		cout << queue.dequeue() << endl;
	}

	MyList list;

	cout << list.size() << endl;

	list.add(1);
	list.add(2);
	list.add(3);

	cout << list.indexOf(1) << endl;
	cout << list.indexOf(2) << endl;
	cout << list.indexOf(3) << endl;
	cout << list.indexOf(4) << endl;

	list.remove(2);

	cout << list.size() << endl;

	return 0;
}



