/*
 * my_queue.cpp
 *
 *  Created on: Mar 19, 2013
 *      Author: promulo
 */

#include "../headers/my_queue.h"

#include <iostream>

MyQueue::MyQueue() : m_head(NULL), m_tail(NULL), m_size(0)
{
}

MyQueue::~MyQueue()
{
	while(!empty()) {
		dequeue();
	}

	m_tail = NULL;
}

void MyQueue::enqueue(int element)
{
	QueueNode* newNode = new QueueNode;
	newNode->next = NULL;
	newNode->value = element;

	if (empty()) {
		m_head = newNode;
		m_tail = newNode;
	} else {
		m_tail->next = newNode;
		m_tail = newNode;
	}

	++m_size;
}

int MyQueue::dequeue()
{
	if (empty()) {
		std::cout << "empty queue" << std::endl;
		return -1;
	}

	int ret = m_head->value;

	QueueNode* node = m_head;

	m_head = m_head->next;

	delete node;
	node = NULL;

	--m_size;

	return ret;
}
