package mydatastructures.datastructures;

public class Queue {
	private Object[] elements;
	
	private int head;
	
	private int tail;

	public Queue(int n) {
		elements = new Object[n+1];
		head = tail = 0;		
	}

	public boolean isEmpty() {
		return head == tail;
	}

	public void enqueue(Object element) throws Exception {
		if (head == tail + 1) {
			throw new Exception("overflow");
		}
		
		elements[tail] = element;
		
		tail = (tail == elements.length - 1) ? 0 : tail + 1;
	}

	public Object dequeue() throws Exception {
		if (isEmpty()) {
			throw new Exception("underflow");
		}
		
		Object ret = elements[head];
		
		head = (head == elements.length - 1) ? 0 : head + 1;
		
		return ret;
	}

}
