package mydatastructures.datastructures;

public class Stack {
	
	private Object[] elements;
	
	private int top;
	
	public Stack(int n) {
		elements = new Object[n];
		top = -1;
	}

	public boolean isEmpty() {
		return top == -1;
	}

	public void push(Object element) throws Exception {
		if (++top >= elements.length) {
			throw new Exception("overflow");
		}
		
		elements[top] = element;		
	}

	public Object pop() throws Exception {
		if (isEmpty()) {
			throw new Exception("underflow");
		}
		
		return elements[top--];
	}
	
	
}
