package mydatastructures.datastructures;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import org.junit.Test;

public class BinaryTreeTest {

	@Test
	public void testTreeInsertAndSearch() {
		BinaryTree tree = new BinaryTree();
		
		assertEquals(-1, tree.getMinimum());
		assertEquals(-1, tree.getMaximum());
		
		tree.insert(3);
		
		assertEquals(3, tree.getMinimum());
		assertEquals(3, tree.getMaximum());
		
		tree.insert(1);
		
		assertEquals(1, tree.getMinimum());
		assertEquals(3, tree.getMaximum());
		
		tree.insert(2);
		tree.insert(4);
		
		assertEquals(1, tree.getMinimum());
		assertEquals(4, tree.getMaximum());
		
		assertNotNull(tree.search(4));
		assertNotNull(tree.search(2));
		assertNotNull(tree.search(3));
		assertNotNull(tree.search(1));
		
		assertNull(tree.search(0));
		
		tree.insert(0);
		assertNotNull(tree.search(0));
		
		tree.printInOrder();
	}

}
