package mydatastructures.datastructures;

import static org.junit.Assert.*;

import org.junit.Test;

public class QueueTest {

	@Test
	public void test() throws Exception {
		Queue emptyQueue = new Queue(0);
		assertTrue(emptyQueue.isEmpty());
		
		Queue oneElementQueue = new Queue(1);
		assertTrue(oneElementQueue.isEmpty());
		
		oneElementQueue.enqueue("1");
		assertFalse(oneElementQueue.isEmpty());
		assertEquals("1", oneElementQueue.dequeue());
		assertTrue(oneElementQueue.isEmpty());
		
		Queue threeElementQueue = new Queue(3);
		assertTrue(threeElementQueue.isEmpty());
		
		threeElementQueue.enqueue("1");
		threeElementQueue.enqueue("2");
		threeElementQueue.enqueue("3");
		
		assertFalse(threeElementQueue.isEmpty());
		
		assertEquals("1", threeElementQueue.dequeue());
		assertEquals("2", threeElementQueue.dequeue());
		assertEquals("3", threeElementQueue.dequeue());
		
		assertTrue(threeElementQueue.isEmpty());
	}

}

