package mydatastructures.datastructures;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class StackTest {

	@Test
	public void testStackCreation() throws Exception {
		Stack emptyStack = new Stack(0);		
		assertTrue(emptyStack.isEmpty());
		
		Stack oneElementStack = new Stack(1);		
		assertTrue(oneElementStack.isEmpty());
		
		oneElementStack.push("1");
		assertFalse(oneElementStack.isEmpty());
		
		assertEquals("1", oneElementStack.pop());
		assertTrue(oneElementStack.isEmpty());
		
		Stack threeElementStack = new Stack(3);
		assertTrue(threeElementStack.isEmpty());
		
		threeElementStack.push("1");
		threeElementStack.push("2");
		threeElementStack.push("3");
		
		assertFalse(threeElementStack.isEmpty());
		
		assertEquals("3", threeElementStack.pop());
		assertEquals("2", threeElementStack.pop());
		assertEquals("1", threeElementStack.pop());
		
		assertTrue(threeElementStack.isEmpty());
	}

}
