/*
 * my_list.h
 *
 *  Created on: Mar 19, 2013
 *      Author: promulo
 */

#ifndef MY_LIST_H_
#define MY_LIST_H_

#include "my_defines.h"

typedef MyNodeDouble ListNode;

class MyList {

 public:
	MyList();

	virtual ~MyList();

	void add(int element);

	void remove(int element);

	void removeFrom(int index);

	inline int size() { return m_size; }

	inline bool empty() { return m_size == 0; }

	int indexOf(int element);

 private:
	MyNodeDouble* m_head;

	MyNodeDouble* m_tail;

	int m_size;

};



#endif /* MY_LIST_H_ */
