/*
 * my_stack.cpp
 *
 *  Created on: Mar 19, 2013
 *      Author: promulo
 */

#include "../headers/my_stack.h"

#include <iostream>

MyStack::MyStack() : m_top (NULL)
{
}

MyStack::~MyStack()
{
	while (!empty()) {
		pop();
	}
}

void MyStack::push(int element)
{
	StackNode* newNode = new StackNode;
	newNode->next = NULL;
	newNode->value = element;

	if (empty()) {
		m_top = newNode;
	} else {
		newNode->next = m_top;
		m_top = newNode;
	}
}

int MyStack::pop()
{
	if (empty()) {
		std::cout << "empty stack" << std::endl;
		return -1;
	}

	int ret = m_top->value;

	StackNode* popped = m_top;

	m_top = popped->next;

	delete popped;
	popped = NULL;

	return ret;
}

