package mydatastructures.datastructures;

import static org.junit.Assert.*;

import org.junit.Test;

public class HashTableTest {

	@Test
	public void testHashTableChaining() {
		HashTable table = new HashTable();
		
		table.insert('a');
		assertTrue(table.containsValue('a'));
		
		table.insert('A');
		assertTrue(table.containsValue('A'));
		
		table.delete('A');
		assertTrue(table.containsValue('a'));
		assertFalse(table.containsValue('A'));
	}

}
